// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package query

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// QueryClient is the client API for Query service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type QueryClient interface {
	// BirthDetails returns the birth details for person matching provided
	// identifier.
	BirthDetails(ctx context.Context, in *BirthDetailsRequest, opts ...grpc.CallOption) (*BirthDetailsReply, error)
	// NameDetails returns the name details for person matching provided
	// identifier.
	NameDetails(ctx context.Context, in *NameDetailsRequest, opts ...grpc.CallOption) (*NameDetailsReply, error)
	// ResidentialAddress returns the residential address for person matching provided
	// identifier.
	ResidentialAddress(ctx context.Context, in *ResidentialAddressRequest, opts ...grpc.CallOption) (*ResidentialAddressReply, error)
	// MarriageDetails returns the marriage details for person matching provided
	// identifier.
	MarriageDetails(ctx context.Context, in *MarriageDetailsRequest, opts ...grpc.CallOption) (*MarriageDetailsReply, error)
	// PersonDetails returns all details for person matching provided
	// identifier.
	PersonDetails(ctx context.Context, in *PersonDetailsRequest, opts ...grpc.CallOption) (*PersonDetailsReply, error)
}

type queryClient struct {
	cc grpc.ClientConnInterface
}

func NewQueryClient(cc grpc.ClientConnInterface) QueryClient {
	return &queryClient{cc}
}

func (c *queryClient) BirthDetails(ctx context.Context, in *BirthDetailsRequest, opts ...grpc.CallOption) (*BirthDetailsReply, error) {
	out := new(BirthDetailsReply)
	err := c.cc.Invoke(ctx, "/query.Query/BirthDetails", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *queryClient) NameDetails(ctx context.Context, in *NameDetailsRequest, opts ...grpc.CallOption) (*NameDetailsReply, error) {
	out := new(NameDetailsReply)
	err := c.cc.Invoke(ctx, "/query.Query/NameDetails", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *queryClient) ResidentialAddress(ctx context.Context, in *ResidentialAddressRequest, opts ...grpc.CallOption) (*ResidentialAddressReply, error) {
	out := new(ResidentialAddressReply)
	err := c.cc.Invoke(ctx, "/query.Query/ResidentialAddress", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *queryClient) MarriageDetails(ctx context.Context, in *MarriageDetailsRequest, opts ...grpc.CallOption) (*MarriageDetailsReply, error) {
	out := new(MarriageDetailsReply)
	err := c.cc.Invoke(ctx, "/query.Query/MarriageDetails", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *queryClient) PersonDetails(ctx context.Context, in *PersonDetailsRequest, opts ...grpc.CallOption) (*PersonDetailsReply, error) {
	out := new(PersonDetailsReply)
	err := c.cc.Invoke(ctx, "/query.Query/PersonDetails", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// QueryServer is the server API for Query service.
// All implementations must embed UnimplementedQueryServer
// for forward compatibility
type QueryServer interface {
	// BirthDetails returns the birth details for person matching provided
	// identifier.
	BirthDetails(context.Context, *BirthDetailsRequest) (*BirthDetailsReply, error)
	// NameDetails returns the name details for person matching provided
	// identifier.
	NameDetails(context.Context, *NameDetailsRequest) (*NameDetailsReply, error)
	// ResidentialAddress returns the residential address for person matching provided
	// identifier.
	ResidentialAddress(context.Context, *ResidentialAddressRequest) (*ResidentialAddressReply, error)
	// MarriageDetails returns the marriage details for person matching provided
	// identifier.
	MarriageDetails(context.Context, *MarriageDetailsRequest) (*MarriageDetailsReply, error)
	// PersonDetails returns all details for person matching provided
	// identifier.
	PersonDetails(context.Context, *PersonDetailsRequest) (*PersonDetailsReply, error)
	mustEmbedUnimplementedQueryServer()
}

// UnimplementedQueryServer must be embedded to have forward compatible implementations.
type UnimplementedQueryServer struct {
}

func (UnimplementedQueryServer) BirthDetails(context.Context, *BirthDetailsRequest) (*BirthDetailsReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BirthDetails not implemented")
}
func (UnimplementedQueryServer) NameDetails(context.Context, *NameDetailsRequest) (*NameDetailsReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method NameDetails not implemented")
}
func (UnimplementedQueryServer) ResidentialAddress(context.Context, *ResidentialAddressRequest) (*ResidentialAddressReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ResidentialAddress not implemented")
}
func (UnimplementedQueryServer) MarriageDetails(context.Context, *MarriageDetailsRequest) (*MarriageDetailsReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method MarriageDetails not implemented")
}
func (UnimplementedQueryServer) PersonDetails(context.Context, *PersonDetailsRequest) (*PersonDetailsReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method PersonDetails not implemented")
}
func (UnimplementedQueryServer) mustEmbedUnimplementedQueryServer() {}

// UnsafeQueryServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to QueryServer will
// result in compilation errors.
type UnsafeQueryServer interface {
	mustEmbedUnimplementedQueryServer()
}

func RegisterQueryServer(s grpc.ServiceRegistrar, srv QueryServer) {
	s.RegisterService(&Query_ServiceDesc, srv)
}

func _Query_BirthDetails_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BirthDetailsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QueryServer).BirthDetails(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/query.Query/BirthDetails",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QueryServer).BirthDetails(ctx, req.(*BirthDetailsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Query_NameDetails_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(NameDetailsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QueryServer).NameDetails(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/query.Query/NameDetails",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QueryServer).NameDetails(ctx, req.(*NameDetailsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Query_ResidentialAddress_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ResidentialAddressRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QueryServer).ResidentialAddress(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/query.Query/ResidentialAddress",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QueryServer).ResidentialAddress(ctx, req.(*ResidentialAddressRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Query_MarriageDetails_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(MarriageDetailsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QueryServer).MarriageDetails(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/query.Query/MarriageDetails",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QueryServer).MarriageDetails(ctx, req.(*MarriageDetailsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Query_PersonDetails_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PersonDetailsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QueryServer).PersonDetails(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/query.Query/PersonDetails",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QueryServer).PersonDetails(ctx, req.(*PersonDetailsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Query_ServiceDesc is the grpc.ServiceDesc for Query service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Query_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "query.Query",
	HandlerType: (*QueryServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "BirthDetails",
			Handler:    _Query_BirthDetails_Handler,
		},
		{
			MethodName: "NameDetails",
			Handler:    _Query_NameDetails_Handler,
		},
		{
			MethodName: "ResidentialAddress",
			Handler:    _Query_ResidentialAddress_Handler,
		},
		{
			MethodName: "MarriageDetails",
			Handler:    _Query_MarriageDetails_Handler,
		},
		{
			MethodName: "PersonDetails",
			Handler:    _Query_PersonDetails_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "query-api/query/query.proto",
}
